;0JDIODE 260414 Cadran_0
;Cadran_0 en general pour A110 1600 et tout cadran dont l'aiguille reste  0 quand on dbranche le capteur de niveau

;Avec SUB de verification des blocs de diodes, activables ventuellement en dbut de listing
;avec "chant du cygne", c'est  dire ecriture en EEP5 de la  valeur TAFF du cadran  la  coupure du contact
;Au prochain dmarrage celle valeur sera affiche pendant tout le premier cycle de mesure.

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;PRINCIPE de FONCTIONNEMENT;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;On utilise un  bloc de 3  diodes en srie pour chaque niveau de jauge: 1/4, 2/4, 3/4, 4/4, B1 en bas, B4 en haut du reservoir
; On mesure la tension de cathode V1 d'un bloc
;V1 est mesure une premire fois,  juste avant la chauffe de 15s,  puis une deuxime fois,V2,1s aprs arret de la chauffe
;Ceci permet de detecter si une jonction est  l'air libre ou immerge.

; le convertisseur numrique-analogique, le CAN, gnre 1024 units pour 5V soit 5/1024= 4.9mV environ par unit
; A 20C
;Si les 3  diodes sont au sec, on constate que DV=V2-V1 = 30 units environ soit 150mV
;
;Si 3 diodes sont immerges, V2-V1 = 8u environ soit 40mV

;Si 1 ou 2 diodes sont immerges, on trouve une valeur entre 150 et 40mV, et dans ce cas,

;on affiche une position intermdiaire impaire (1/8,3/8,5/8,7/8) de l'aiguille au cadran 

;Le temps d'affichage TAi pour ces intermdiaires est calcul  partir des 4 valeurs 1/4,2/4,3/4 et 4/4
;saisies au moment de l'talonnage par simple interpollation: ex TA3/8= (TA1/4 + TA1/2) / 2

;Quand on met le contact, on doit voir l'aiguille afficher 1/8, 1/4, puis..7/8,4/4 puis la position lors du dernier arrt moteur.


;Dure totale du cycle :4*(15s chauffe,60s repos)= 6minutes, on met  jour le cadran  la fin d'un cycle.

; Les jonction utilise sont des diodes au silicium de type 1N4007 ou quivalent,  
; Il n'y a pratiquement aucun aucun chauffement notable detectable au doigt, une diode dissipant 0.9V*0.5A <0.45Watt pendant 15s
; avec un cycle   de chauffe de priode 5mn. La puissance moyenne dissipe dans un bloc est donc (15/75)*0.45 =  90mW
; Valeurs typiques pour un bloc: avant chauffe V1=3.3V, pendant la chauffe 2.3V

;L'talonnage du cadran de l'auto est  effectuer une seule fois, les 4 valeurs tant mmorises en mmoire EEPROM.
;Voir le dtail de la procedure en fin de programme

;;;;;;;;;;;FONCTIONS ANNEXES avec les pouton poussoir BPE (Enter) et BPP (Plus);;;;;;;;;;;;;;;;;;;;;;;;;;;;

;Pour entrer en mode ETALONNAGE du cadran: maintenir appuy le bouton poussoir BPE puis mettre le contact. Voir plus loin le dtail

;Pour dmarrer le LOG en mmoire EEPROM de groupes de 4 caractres par bloc de diode
;On attend LED2 (verte)ON, et on pousse BPP d'o LED1(rouge)ON qui signifie log en cours
;On log:------------- 'Ndebloc et V1_H'----		------DV---- 	---TAFP----	------TAFF---------

;Pour arrter le log, attendre LED2 (verte)ON, pousser BPP, d'ouLED1 et 2  off. Ceci crit 99 99 99  en EEprom pour sidentifier un arret de log
;On peut redmarrer un nouveau log ds que la LED2(verte)  est ON
;Pour effacer tout le log en EEPROM,  maintenir appuy le bouton poussoir BPP puis mettre le contact. Attendre LED1 et 2  off pour la fin du RAZ.

;***********Pour debug avec ICD3, il FAUT un quartz, les pin 4 libre (ou une resistance  vers +5V), 12 et 13 libres et  MCLR_On  !!
; 12 et 13 libre = deconnexion des deux LED
;Aprs debug, mode Production, pas de quartz, MCLR ON,. Paramtre DEBUG sans influence
;Pour oscillateur INTERNE 4MHz ,  _INTRC_IO  et OSCCON =h'60' ;OSCCON sans influence donc rien  changer dans le code si HS_OSC
;PIEGESi  MCLR_Off,  la pin 4 est libre pour l'utiliser en INPUT seulement!!!

       list      p=16F88             ; list directive to define processor
       #include <p16F88.inc>         ; processor specific variable definitions
		ERRORLEVEL	-302			;pas de warnings pour les banks
;Program Configuration Register 1  PIEGE sur 16F88: il FAUT _HS_OSC meme  4MHz!!!


		__CONFIG    _CONFIG1, _CP_OFF & _CCP1_RB0 & _DEBUG_OFF & _WRT_PROTECT_OFF & _CPD_OFF & _LVP_OFF & _BODEN_OFF & _MCLR_ON & _PWRTE_OFF & _WDT_Off & _HS_OSC
		__CONFIG    _CONFIG2, _IESO_Off & _FCMEN_OFF
		
;	__CONFIG    _CONFIG1, _CP_OFF & _CCP1_RB0 & _DEBUG_OFF & _WRT_PROTECT_OFF & _CPD_OFF & _LVP_OFF & _BODEN_OFF & _MCLR_ON & _PWRTE_OFF & _WDT_Off & _INTRC_IO		
		
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Laisse  0 ou mettre 1 suivant le type de cadran;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;		



lCADRAN	equ 	0		;contact mis,capteur dconnect, mettre 0 si l'aiguille du cadran  reste au zro (usuel sur A110 1600), mettre 1 si elle vient sur 4/4	(en general les A110 1300)


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;	
	#DEFINE	BPP		PORTB,5			;BP Plus, pin 11,  0 pour ON, input
	#DEFINE	BPE		PORTB,0			;BP Entre, pin 6, 0 pour ON, input, aussi IT de surveillance coupure alim 12V
	
	#DEFINE	LED1		PORTB,6			;L1 pin 12,0 pour ON, out  ROUGE
	#DEFINE	LED2		PORTB,7			;L2 pin 13,0 pour ON, out  VERTE (ou autre)
	
	#DEFINE	CADRAN	PORTA,0		;pin 17,out
	
	#DEFINE	D1CH		PORTB,3		;pin 9, chauffage B1, bas de la jauge,1 pour ON, out
	#DEFINE	D2CH		PORTB,2		;pin 8, chauffage B2   ,out
	#DEFINE	D3CH		PORTB,1		;pin 7, chauffage B3   
	#DEFINE	D4CH		PORTB,4		;pin 10, chauffage B4 	
	
	#DEFINE AL	ACCALO  			;abbrviation + facile  crire pour les accumulateurs de D_arith
	#DEFINE AH	ACCaHI  
	#DEFINE BL	ACCbLO  
	#DEFINE BH	ACCbHI  
	#DEFINE CL	ACCcLO 
	#DEFINE CH	ACCcHI 
	
;    Librairie D_arith               b+a ds b;;;;;			;;b  - a  ds b;;;;				;a*b  ds bHigh  cLow;;;;;; 		 b/a  res ds b, reste d
;Entres CAN  D1= pin18,A1,	  D2=pin1,A2   	D3=pin2,A3,   	D4=pin3,A4  INPUT
;
;;;;;;;;;;;;;;;;;;;;LITTERAUX;;;;;;;;;;;;;;;;;;;;;;;
;Une priode d'afffichage de cadran TRAF est 200s.
;A l'talonnage on enregistre les 4 valeurs TAFF pour les positions 1/4, 1/2, 3/4 et 4/4
; Le cadran Veglia vert sur l'Alpine a pour valeurs en s 1/4 -64s 1/2- 88s, 3/4- 113s,4/4-168s      
; lgre variante:						    70  89  123  179
;soit en hexa: 46 59 7B B3
;Autres exemples de cadrans:
; Un cadran de la jauge  essence Oscillati(bleu) 91,103,118,159s
    
;Un cadran noir Veglia de temprature  en s 40 -17s,   60 -38,   80 -63,   100-100

;soit en hexa 11 26 3F 64

lCAD0	equ	d'2'		;utilis pour calculer TA1,  la position d'aiguille 1/8. 
lTCH equ	d'15'	;temps de chauffe en secondes pour un triplet de diodes, I= 480mA environ

lDSH	equ	d'13'			; HUMIDE si DV <=DSH, typique: 8, les 3 diodes sont immerges
;;;;;;entre les deux, partiellement humide, donc position intermdiaire de l'aiguille soit 1/8,3/8,5/8,7/8
lDSS	equ	d'21'			;SEC si DV >DSH, typique :plus de 30, les 3 diodes sont au sec

lTRAF		equ		d'200'		;dure en 10s de la periode du cadran, soit 2ms
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Les variables		
    cblock  h'20' 
      ACCaLO  				;variables de la lib  D_Arith
	ACCaHI  
	ACCbLO  
	ACCbHI  
	ACCcLO 
	ACCcHI  
	ACCdLO  
	ACCdHI  
	Dtemp
	Dflags  
	
	NBT					;N de bloc en cours de test, 1 4
    	TRAF					;priode fixe pour alimenter le cadran,  2ms
    	TAFP					;priode potentielle durant le calcul d'un cycle
    							;Affichage cadran
	TAFF					;Vout ON pendant Taff, OFF pendant Toff,   Ton + Toff= Traf
	TOFF					;Vout OFF pendant Toff
	TAFFOLD				;juste avant coupure alim 12V.Utilis pour le premier cycle seulement
		
	TA0						;temps en s pour afficher  0
	TA1						;temps en s pour afficher 1/8 au cadran
	TA2						;2/8	Etalon 1/4  dure de  0  200s, units de 10s , pour TAFF  
	TA3						;3/8		
	TA4						;4/8	Etalon 2/4
	TA5						;5/8
	TA6						;6/8	Etalon 3/4 
	TA7						;7/8
	TA8						;8/8	Etalon	4/4
    
	XTMP 						;temporaireSUB: Chauffe, Raz_log
	TMP						;temporaire SUB: Affic_cadran,Setup_delay, Wait_ns,WR_w_EEP
	cs							;temporaire SUB:Affic_15s, Wait_wms
	CT							;temporaire	SUB Affic_1s, Lire_aiguille
	
	V_L							;rempli par SUB Get_V, V_H dans w
	V1_H
	V1_L						; lecture  froid
	V2_H	
	V2_L		;				lecture aprs 30s de chauffage
	DV							;V2  - V1 positif sauf problme

	TCH					;dure de chauffe, typique 30s
	
	FCADRAN				;Flag de cadran = 1 pour aiguille sur 4/4 qd non connect,  sinon 0
	FLOG					;demande de log par BPP pouss en cours d'execution, arret par BPP de nouveau
	DSH					;seuil pour humide
	DSS					;seuil pour sec
	endc
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;		
START   ORG     0               
 		clrf	INTCON   
  	   	 goto    Main
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;  	  
;Arrive de l'IT sur pin 6 quand l'alim +12V est coupe 	 
  	   	 org	4				;
  	   	 banksel	EEADR
  	   	 movlw	4
  	   	 movwf	EEADR
  	   	 banksel	0
  	   	 movfw		TAFF	;stocker en EEp4 l"affichage actuel du cadran

  	   	 call	WR_w_EEP	;ultime effort...
  	   	 
	   	 bcf		INTCON,INTF
 	   	 retfie		; tout hasard...
  ;	   	 goto	$			;on attend ici la dcharge du condensateur connect au +5V
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; 
  	   	 
Main                                                                                                                                                                        	
         	 call		INIT
;	       bsf	FLOG,0			; flag de Flog pour dmarrer le log ds le premier cycle

;		call	VERIF_B1			;Activable sparemment et on y reste
;		call	VERIF_B2
;		call	VERIF_B3
;		call	VERIF_B4
deb
		call		TST_B1
		call		AFFIC_60s	
		
		call		TST_B2
		call		AFFIC_60s	
		
		call		TST_B3	
		call		AFFIC_60s	
				
		call		TST_B4	
		call		AFFIC_60s		
		
		movfw	TAFP	;Mise  jour de l'affichage pour prochain cycle
		movwf	TAFF	;	
						
		goto	deb							
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;LES SUBs************************************
AFFIC_60s					;SUB d'attente ,  cadran activ, chauffage arrt
	movlw d'60'				;pargne le 7805
	movwf	cs
	call	AFFIC_1s
	decfsz	cs,f
	goto $-2
	return
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;	
AFFIC1A4					;SUB remplit TA2,4,6,8 affiche 2s de 1/8  8/8
							;lit les 4 valeurs de l'EEP, entre 0 et 3	
		call	RD_w_EEP			
		movwf	Ta2				
		call	RD_w_EEP			
		movwf	Ta4		
		call	RD_w_EEP		
		movwf	Ta6		
		call	RD_w_EEP		; 	
		movwf	Ta8		
		call	RD_w_EEP		; en EEP4, on va chercher TAFFOLD	
		movwf	TAFFOLD			
		
		call	CALC_INTER	
			
		movfw	TA1
		movwf	TAFF
		call	AFFIC_1s		;affiche TA1
		
		movfw	TA2
		movwf	TAFF		;pour  afficher 2/4 pendant 1s

		call	AFFIC_1s	;afficher aiguille au 1/4 pour 1s,au demarrage
		
		movfw	TA3
		movwf	TAFF
		call	AFFIC_1s		;affiche TA3	

		movfw	Ta4		;	
		movwf	TAFF

		call	AFFIC_1s	;afficher aiguille au 1/2 pour 1s,au demarrage
		
		movfw	TA5
		movwf	TAFF
		call	AFFIC_1s		;affiche TA5

		movfw	Ta6				
		movwf	TAFF

		call		AFFIC_1s	;afficher aiguille au 3/4 pour 1s,au demarrage
		
		movfw	TA7
		movwf	TAFF
		call	AFFIC_1s		;affiche TA7	


		movfw	Ta8	;		
		movwf	TAFF	;LED1et2 encore ON
		call	AFFIC_1s	;afficher aiguille au 4/4 pour 1s,au demarrage
		
		movfw	TAFFOLD
		movwf	TAFF	;re afficher l'ancien cadran avant l'arret.
		call	AFFIC_1s
		bsf		LED1	;LEDs off
		bsf		LED2
		banksel	EEADR
		movlw	h'10'		;prpare pour log
		movwf	EEADR
		banksel	0
	
		return
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
AFFIC_1s						;SUB affiche le cadran 1s. Compte sur Taff garnie et la respecte
								; on va afficher pendant 510 periodes Traf
		movlw	d'255'			;255*2ms donne 0.5s
		movwf	CT
af2
		call	AFFIC_CADRAN
		decfsz	CT,f
		goto	af2
		movlw	d'255'			;255*2ms donne 0.5s
		movwf	CT
af3
		call	AFFIC_CADRAN
		decfsz	CT,f
		goto	af3		
		return		
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;		
AFFIC_CADRAN				;SUB affiche le cadran pendant une periode soit Traf
								;compte sur Taff garni et la respecte
								;Durant Taff, Vout=1 et durant Toff, Vout = 0, ou l'inverse
		movfw	Taff
		movwf	TMP			;ne pas toucher  Taff							
		movfw	Taff
		subwf	Traf,w			;Traf - Taff ds Toff
		movwf	Toff								
								
		movf	TMP,f			;sur place, Taff
		btfsc	STATUS,Z
		goto	af4				;Taff=0 pas de mouvement d'aiguille
								; On va tirer l'aiguille  droite
								;Phase (jusqu' af4) de propulsion aiguille vers 4/4, dure Taff				
		bsf		CADRAN		;assume CADRAN type 0, aiguille  0  vide, entre cadran  la masse
		btfsc	FCADRAN,0
		bcf		CADRAN		;non, c'est du type 1, aiguille  4/4  vide	, entre cadran au +12V
af7														;
		nop
		goto	$+1				;boucle 10s
		goto	$+1
		goto	$+1
		decfsz	TMP,f			;pendant Taff 10s
		goto	af7				
af4							
		movf	Toff,f			;sur place
		btfsc	STATUS,Z
		goto	aout			;Toff=0,aiguille sur 4/4 sortir		
								;Phase (jusqu' aout) de maintien aiguille  0, duree Toff
		bcf		CADRAN			;assume CADRAN type 0
		btfsc	FCADRAN,0
		bsf		CADRAN			;non, c'est du type 1, aiguille  4/4  vide
af8
		nop
		goto	$+1				;boucle 10s
		goto	$+1
		goto	$+1
		decfsz	Toff,f			;pendant Taff 10s
		goto	af8
aout
		return	
;;;;;;;	;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
BLINK						;SUB alterne LED 1 et 2 , etalonnage de 4/4
etf								;
	bcf	LED1
	bsf	LED2
	call	WAIT_50ms
	call	WAIT_50ms
	bsf	LED1
	bcf	LED2
	call	WAIT_50ms
	call	WAIT_50ms	
	btfsc	BPP
	goto	etf
	bsf	LED2	;all LED off
	return
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
CALC_DV						;SUB  DV=V2-V1,8b,   V2 tj >V1 b-a ds b, ds DV et w
		movfw	V2_H			;V2 ds b
		movwf	bh
		movfw	V2_L
		movwf	bl

		movfw	V1_H			;V1 ds a
		movwf	ah
		movfw	V1_L
		movwf	al
		call	D_sub				;DV	ds b
		btfss	bh,7
		goto	tvb				;DV>0, tt va bien
;		call	LOG				;anomalie V2<V1, 
		movlw	1				;pour attirer l'oeil
		call	WR_w_EEP
		movlw	2
		call	WR_w_EEP
		movlw	3
		call	WR_w_EEP
		movfw	V1_H
		call	WR_w_EEP		; on log V1, V2 et N du bloc en cours
		movfw	V1_L
		call	WR_w_EEP
		movfw	V2_H
		call	WR_w_EEP
		movfw	V2_L
		call	WR_w_EEP
		movfw	NBT		;N de bloc en cours 
		call	WR_w_EEP	; et on continue avec DV grand en valeur absolue donc >sec, dont TAFP non affect	
tvb
		movfw	bl
		movwf	DV		;
		return		
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
CALC_INTER				;SUB de calcul des Taff 1,3,5,7
	movlw	lCAD0				;ZERO
	movwf	TA0
	
	bcf	STATUS,C			;calcul de TA1 = TA0/2  +  TA2/2
	rrf	TA0,w
	movwf	TA1				;TA0/2 ds TA1
	bcf	STATUS,C
	rrf	TA2,w				;TA2/2
	addwf	TA1,f
	
	bcf	STATUS,C			;calcul de TA3 = TA2/2  +  TA4/2
	rrf	TA2,w
	movwf	TA3				
	bcf	STATUS,C
	rrf	TA4,w				;
	addwf	TA3,f
	
	bcf	STATUS,C			;calcul de TA5 = TA4/2  +  TA6/2
	rrf	TA4,w
	movwf	TA5			;
	bcf	STATUS,C
	rrf	TA6,w				
	addwf	TA5,f
	
	bcf	STATUS,C			;calcul de TA7 = TA46/2  +  TA8/2
	rrf	TA6,w
	movwf	TA7			;
	bcf	STATUS,C
	rrf	TA8,w				
	addwf	TA7,f
	return
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
CHAUFFE				;SUB chauffe un trio de diodes  360mA , 30s
						; et detecte les demande de log (BPP)
		bcf	LED2		;set LED2 ON, creneau pour demander ou arreter log via BPP
		movfw TCH
		movwf	XTMP
chat
		btfsc	BPP	; Demande de log si BPP appuy,=0 , tt moment
		goto	cfd3	; pas de BPP 
		call		VER_BPP		;attendre relachement du BPP
		btfss	FLOG,0	;  est on dj en log?
		goto	cfd1	;non, set LED1, on veut le log
		bsf	LED1	; oui, on veut arreter le log, LED1 et 2 OFF
		bsf	LED2
		clrf	FLOG	;plus de log
		movlw	h'99'	;marqueur de fin de log, temporaire ou non
		call		WR_w_EEP
		movlw	h'99'	;marqueur de fin de log, temporaire ou non
		call		WR_w_EEP
		movlw	h'99'	;marqueur de fin de log, temporaire ou non
		call		WR_w_EEP		
cfd3
		call		AFFIC_1s
		decfsz	XTMP,f
		goto	chat
		bsf	LED2		;LED2 off, fin du creneau de demande de log
		return
cfd1				;on veut le log
		bcf	LED1		;LED1 on
		bsf	FLOG,0	;set le flag de log pour les SUB TST_Bi
		goto	cfd3
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
ETALON				;SUB d'talonnage du cadran,4 val  ecrites en EEP
						;laisse EEADR pointe vers l'adresse 4 de l'EEPROM  pour log ventuel
	bcf		LED1		;LED1 ONpour 1/4					
	call		VER_BPE	;Attendre fin appui
;						;Noter que EEPADR pointe  0 en EEP
	call		LIRE_AIGUILLE; get  TAFF pour 1/4 et stock le en EEP0
	
	bsf	LED1
	bcf	LED2			;LED2 on, Led 1 off pour 2/4EEP1
	call		LIRE_AIGUILLE
	
	
	bcf	LED1			;Led 1 et 2 on pour 3/4
	bcf	LED2
	call		LIRE_AIGUILLE; EEP2
	
	call		BLINK			; les deux dioodes en alternance pour 4/4
		
	call		LIRE_AIGUILLE;EEP3
	
	movlw	0
	call		WR_w_EEP	;0 en EEP4, pour TAFFOLD
	
	bsf	LED1			;fin de saisie  all LED Off
	bsf	LED2

	goto	$			;on y reste
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
INIT						;SUB initialisation I/O
	bcf		INTCON,GIE		;pas d'IT
	clrf	PORTB				;precaution avant affectation 1/0
	clrf	PORTA
	bcf		status,irp			;accs indirect aux pages 0 et 1 pour FSR
	banksel	EEADR
	clrf		EEADR				;pointer en EEP zero
 		
	banksel	TRISA			;bk1
		call	WAIT_1ms	;et aussi NE PAS toucher EEADR trop vite!
	call	WAIT_1ms	;et aussi NE PAS toucher EEADR trop vite!
	call	WAIT_1ms	;et aussi NE PAS toucher EEADR trop vite!	
	call	WAIT_1ms	;et aussi NE PAS toucher EEADR trop vite!
	movlw	h'60'
	movwf	OSCCON		;pour 4MHz oscillateur  interne, OK aussi avec quartz
	movlw	b'11111110'		; 
	movwf	TRISA			;	Voir les #DEFINE au dbut						;
	movlw	b'00100001'		;seules B0 et B5 en entre, les deux BP
	movwf	TRISB			;						
;;;;;;;;;;;;;;;;;;;registre  ANSEL;;;;;;;;;;;;;;;;;;;;;
	clrf	ANSEL			;Toutes entres en numrique car FF au demarrage!!
	bsf		ANSEL,1			;Dclare en entre analogique  A1(17) A2,3,4(1,2,3)
	bsf		ANSEL,2
	bsf		ANSEL,3			;idem    
	bsf		ANSEL,4                     
;;;;;;;;;;;;ADCON1;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	bsf		ADCON1,ADFM		;result right justified, 6msb ds ADRESH = 0 en bk 0
	bcf		ADCON1,ADCS2	;normal conversion clock(not/2)
	bcf		ADCON1,VCFG1	;Votage ref + 5V 
	bcf		ADCON1,VCFG0
;;;;;;;;;;;;;ADCON0;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	banksel	ADCON0			;bk 0

	clrf		ADCON0
	bsf		ADCON0,ADCS0	;conversion clock	Fosc/8 OK car <5MHz	
	bsf		ADCON0,ADON		;Alimenter A/D converter	
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;	
	clrf		FLOG			;pas de demande de log
	
	bsf		LED1		;les 2 LED off
	bsf		LED2
	
	movlw	lCADRAN	;mode normal, pas talon
	movwf	FCADRAN		;type 0 ou 1 de cadran
		
	movlw	lTRAF
	movwf	TRAF
	
	btfss	BPP		;si BPP maintenu, =0, au dmarrage, c'est un RAZ de l'EEP de 4  255
	call		RAZ_LOG	; on n'en reviendra pas
	
	
	btfss	BPE		;si BPE maintenu, =0, au dmarrage, c'est un talonnage du cadran
	call		ETALON	; on n'en reviendra pas	

	

	call		AFFIC1A4	; Lit l'EEP, affiche les 8 repres, 2s chaque, et TAFFOLD
	
	;pour le "chant du cygne"
	banksel	OPTION_REG	;RB0,pin 6, ex BPE, devient IT sur front descendant si alim+12 coupe
	bcf	OPTION_REG,INTEDG	;front descendant sur RB0
	banksel 0
	clrf	INTCON			; tt hasard, si IT enregistre
	bsf	INTCON,PEIE	;peripheral interrupt enable
	bsf	INTCON,INTE	;enable unterrupt external sur RB0
	bsf	INTCON,GIE	;enable all ITs
	
	movlw	lTCH		;temps de chauffe
	movwf	TCH
	
	movlw	lDSH
	movwf	DSH	;seuil pour humide
			
	movlw	lDSS
	movwf	DSS	;seuil pour sec
	
;	movfw	TA0
;	movwf	TAFF		;affiche 1/8au dpart du premier cycle
	clrf	TAFP			;temps d'affichage cadran potentiel
	return	
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
LECT_V					;SUB lit le DAC ds V_L et w=V_H
	call		SetupDelay
	bsf		ADCON0,GO		;dmarrer conversion
	nop
	btfsc	ADCON0,GO		;1 tant que en cours
	goto	$-1

	banksel	ADRESL			;bk1
	movfw	ADRESL
	banksel	ADRESH			;bk0
	movwf	V_L
	movfw	ADRESH
	return
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
LECT_V2			;SUB lit V2 aprs chauffe
	call		AFFIC_1s	;on attend 1s aprs l'arret de la chauffe
	call		LECT_V	;lire V2
	movwf	V2_H
	movfw	V_L
	movwf	V2_L	
	return
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;	
LIRE_AIGUILLE				;SUB pour enregistrer en EEP une position d'aiguille
la1							;BPP tire l'aiguille  droite, et revient  0 si 4/4 dpass
							;BPE clot par enregistrement en EEP de la dernire position d'aiguille
	clrf	TAFF
la2
	movlw	d'25'
	movwf	CT
	call	AFFIC_CADRAN	;pendant 25*2ms=50ms
	decfsz	CT,f
	goto $-2
	call	WAIT_1ms
	call	WAIT_1ms
	nop
	nop	
	btfss	BPP
	goto	la3		;pouss bouger l'aiguille
	call	AFFIC_1s
	btfsc	BPE
	goto	la2		;E pas pouss
	call	VER_BPE	;fin de saisie de de ce /4
	movfw	TAFF	;enregistrer la position de l'aiguille, 1/4 en EEP 0, 2/4 en EEP 1 etc
	call		WR_w_EEP
	return
la3	
	incf	Taff,f		;Taff++
	movfw	Taff
	subwf	Traf,w
	btfsc	STATUS,C
	goto	la2			;ok, pas au maxi, afficher
	goto	la1		;au max, revenir  0	
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;		
LOG						;SUB log:Nbloc, V1_H, DV,TAFP et TAFF
							; entre avec w encod: N de bloc et V1_H							
	swapf	NBT,w			;exchange nibbles, pour N de bloc en cours en b7-4
	addwf	V1_H,w			;adjoindre les 2 bits de V1_H
	call 	WR_w_EEP	;N de bloc et V1_H


	movfw	V1_L
	call 	WR_w_EEP
		

	movfw	V2_H
	call 	WR_w_EEP
	
	movfw	V2_L
	call 	WR_w_EEP
		
	
	movfw	DV
	call 	WR_w_EEP
	
	movfw	TAFP
	call 	WR_w_EEP
	
	return
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
RAZ_LOG				;SUB RAZ EEP par BPP au depart, de 05  255, la zone de log, preserve Taff1/43/4
	bcf	LED1			;allumer LED1, pendant tout le temps du RAZ
	bcf	LED2			;allumer LED2
	movlw	d'249'		;on passe 256-5=251 fois limit  250 
	movwf	XTMP
	
	banksel	EEADR		;bk2
	movlw	h'05'
	movwf	EEADR		;pointer en adresse 05 de l'EEP
	banksel	0
rz1
	movlw	0
	call	WR_w_EEP	;ecrire 0 en 05,,,,255
	
	decfsz	XTMP,f
	goto	rz1
	
	bsf	LED1			;teindre
	bsf	LED2			;teindre LED2
	goto	$			;boucle infinie
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
RD_w_EEP				;SUB lit ds w l'EEP pointe par EEADR, puis on fait EEADR++

	banksel	EECON1		;Bank 3
	bcf		EECON1,EEPGD;b7=0 pointe vers EEP
	bsf		EECON1,RD	;b0 =1 pour ReaD

	banksel	EEDATA		;bk2
	movfw	EEDATA		;charger car
	incf	EEADR,f		;EEADR++
	banksel	PIR1		;bk0
	movwf	cs	;save
	call	WAIT_1ms	;et aussi NE PAS toucher EEADR trop vite!
	call	WAIT_1ms	;et aussi NE PAS toucher EEADR trop vite!
	call	WAIT_1ms	;et aussi NE PAS toucher EEADR trop vite!	
	call	WAIT_1ms	;et aussi NE PAS toucher EEADR trop vite!	
	movfw	cs	;reload
	return
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;	
SETUPDELAY					;Attente pour la conversion A to D
	movlw	3
	movwf	TMP
	decfsz	TMP,f
	goto	$-1
	return
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
TST_B1						;SUB de test du bloc de diodes B1, le plus bas, calcul de TAFP si non sec
	movlw	1
	movwf	NBT			;N) de bloc en cours de test
	
	movfw	TA0				;pour bloc 1:assume panne sche!
	movwf	TAFP		
	bcf		ADCON0,CHS2		;CAD sur patte 18, RA1
	bcf		ADCON0,CHS1
	bsf		ADCON0,CHS0	
	call		LECT_V
	movwf	V1_H
	movfw	V_L
	movwf	V1_L
	
	bsf		D1CH			; pin 9 dmarre chauffe de D1
	call		CHAUFFE		;pendant ce temps  on affiche le cadran
	bcf		D1CH			;arreter chauffe
	call		LECT_V2
	call		CALC_DV
		
	subwf	DSH,w			;seuil bloc humide
	btfss	STATUS,C
	goto	d1p				;DV>lDSH, 
	movfw	TA2				;DV<= lDSH, bloc humide
	movwf	TAFP			;afficher 2/8 potentiel
	goto	d1r				;sortir	
d1p
	movfw	DV
	subwf	DSS,w			;seuil bloc sec
	btfss	STATUS,C
	goto	d1r				;DV>lDSS ,sec, panne sche, garder TAFP=TA0
	movfw	TA1				;DV<= lDSS, humidit partielle
	movwf	TAFP			;afficher 1/8 potentiel
d1r
	btfss	FLOG,0
	goto	d1y				;pas de log
	call		LOG			;si Flog = 1
d1y
	return			
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
TST_B2							;SUB de test du bloc de diodes B2,  calcul de TAFP si non sec
	movlw	2
	movwf	NBT			;N de bloc en cours de test
	
	bcf		ADCON0,CHS2		;CAD sur patte 1 RA2
	bsf		ADCON0,CHS1
	bcf		ADCON0,CHS0	
	call		LECT_V
	movwf	V1_H
	movfw	V_L
	movwf	V1_L
	
	bsf		D2CH			; pin 8 dmarre chauffe de D2
	call		CHAUFFE		;pendant ce temps  on affiche le cadran
	bcf		D2CH			;arreter chauffe
	call		LECT_V2
	call		CALC_DV

	subwf	DSH,w	
	btfss	STATUS,C
	goto	d2p				;DV>lDSH
	movfw	TA4				;DV<= lDSH, bloc humide
	movwf	TAFP			;afficher 4/8 potentiel
	goto	d2r				;sortir
d2p
	movfw	DV
	subwf	DSS,w			;seuil bloc sec
	btfss	STATUS,C
	goto	d2r				;DV>lDSS ,sec, sortir sans modifier TAFP
	movfw	TA3				;DV<= lDSS, humidit partielle
	movwf	TAFP			;afficher 3/8 potentiel
d2r
	btfsc	FLOG,0
	call		LOG			;si Flog = 1
	return	
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
TST_B3							;SUB de test du bloc de diodes B3,  calcul de TAFP si non sec
	movlw	3
	movwf	NBT			;N de bloc en cours de test
	
	bcf		ADCON0,CHS2		;CAD sur patte 2 RA3
	bsf		ADCON0,CHS1
	bsf		ADCON0,CHS0	
	call		LECT_V
	movwf	V1_H
	movfw	V_L
	movwf	V1_L
	
	bsf		D3CH			; pin 7 dmarre chauffe de D3
	call		CHAUFFE		;pendant ce temps  on affiche le cadran
	bcf		D3CH			;arreter chauffe
	call		LECT_V2
	call		CALC_DV
	subwf	DSH,w	
	btfss	STATUS,C
	goto	d3p				;DV>lDSH
	movfw	TA6				;DV<= lDSH, bloc humide
	movwf	TAFP			;afficher 6/8 potentiel
	goto	d3r				;sortir
d3p
	movfw	DV
	subwf	DSS,w			;seuil bloc sec
	btfss	STATUS,C
	goto	d3r				;DV>lDSS ,sec, sortir sans TAFP
	movfw	TA5				;DV<= lDSS, humidit partielle
	movwf	TAFP			;afficher 5/8 potentiel
d3r
	btfsc	FLOG,0
	call		LOG			;si Flog = 1
	return		
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
TST_B4				;SUB de test du bloc de diodes B4,  le plus haut,calcul de TAFP si non sec
	movlw	4
	movwf	NBT			;N de bloc en cours de test
	
	bsf		ADCON0,CHS2		;CAD sur patte 3 RA4
	bcf		ADCON0,CHS1
	bcf		ADCON0,CHS0	
	call		LECT_V
	movwf	V1_H
	movfw	V_L
	movwf	V1_L

	bsf		D4CH			; pin 6 dmarre chauffe de D4
	call		CHAUFFE		;pendant ce temps  on affiche le cadran
	bcf		D4CH			;arreter chauffe
	call		LECT_V2
	call		CALC_DV
	subwf	DSH,w	
	btfss	STATUS,C
	goto	d4p				;DV>lDSH
	movfw	TA8				;DV<= lDSH, bloc humide
	movwf	TAFP			;afficher 8/8 potentiel
	goto	d4r				;sortir
d4p
	movfw	DV
	subwf	DSS,w			;seuil bloc sec
	btfss	STATUS,C
	goto	d4r				;DV>lDSS ,sec, sortir sans TAFP
	movfw	TA7				;DV<= lDSS, humidit partielle
	movwf	TAFP			;afficher 7/8 potentiel
d4r
	btfsc	FLOG,0
	call		LOG			;si Flog = 1
	return												
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;	
VER_BPE					;SUB attente BPE relach
	btfss	BPE
	goto	$-1
	call	WAIT_50ms
	btfss	BPE
	goto	$-1
	return
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
VER_BPP					;SUB attente BPPrelach
	btfss	BPP
	goto	$-1
	call	WAIT_50ms
	btfss	BPP
	goto	$-1
	return
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
VERIF_B1					;SUB d'essai du bloc B1. On y  restera
v1
	bsf	FLOG,0				; on log systematiquement en EEP  partir de h10
	clrf	TAFP
	clrf	TAFF			;l'aiguille repart tj de 0
	call	TST_B1
	movfw	TAFP
	movwf	TAFF
	call	AFFIC_60s			;attente pour refroidir le 7805 et etr surtout le bloc
	goto	v1
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
VERIF_B2					;SUB d'essai du bloc B2. On  y restera
v2
	bsf	FLOG,0				; on log systematiquement en EEP  partir de h10
	clrf	TAFP
	clrf	TAFF			;l'aiguille repart tj de 0
	call	TST_B2
	movfw	TAFP
	movwf	TAFF	
	call	AFFIC_60s			;attente pour refroidir le 7805 et etr surtout le bloc
	goto	v2
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
VERIF_B3					;SUB d'essai du bloc B3. On y restera
v3
	bsf	FLOG,0				; on log systematiquement en EEP  partir de h10
	clrf	TAFP
	clrf	TAFF			;l'aiguille repart tj de 0
	call	TST_B3
	movfw	TAFP
	movwf	TAFF
	call	AFFIC_60s			;attente pour refroidir le 7805 et etr surtout le bloc
	goto	v3
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
VERIF_B4					;SUB d'essai du bloc B4. O-+n y restera
v4
	bsf	FLOG,0				; on log systematiquement en EEP  partir de h10
	clrf	TAFP
	clrf	TAFF			;l'aiguille repart tj de 0
	call	TST_B4
	movfw	TAFP
	movwf	TAFF
	call	AFFIC_60s			;attente pour refroidir le 7805 et etr surtout le bloc
	goto	v4
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
WAIT_1ms					;SUB d'attente 1 ms
	movlw	d'250'			;attendre 1ms = 250X4mus
sd	addlw	-1		;                                                  1mus
	btfss	STATUS,Z	;                                                  1
	goto	sd		;                                                  2
	return		
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
WAIT_50ms
	movlw	d'207'		;soit 50 ms.BP apput 8s augmente Taff de 50pnts environ
	movwf	DTEMP
	call	WAIT_1ms
	incfsz	DTEMP,f
	goto	$-2
	return	
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
WAIT_wms					;SUB attente w ms 
	movwf	cs
	call	wait_1ms
	decfsz	cs,f
	goto	$-2
	return
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
WAIT_ns						;SUB d'attente de n/4 s
	movwf	TMP
	movlw	d'100'
	call	WAIT_wms
	decfsz	TMP,f
	goto	$-2
	return
;;;;;;;;;;;;;

WR_w_EEP				;SUB ecrit w en EEP, l ou pointe EEADR. w detruit, puis on faitEEADR++
							;si EEADR repasse  0, on s'arrte en faisant battre l'aiguille du cadran
	movwf	TMP			;sauve w
	call	WAIT_1ms	;et aussi NE PAS toucher EEADR trop vite!
	call	WAIT_1ms	;et aussi NE PAS toucher EEADR trop vite!
	call	WAIT_1ms	;et aussi NE PAS toucher EEADR trop vite!	
	call	WAIT_1ms	;et aussi NE PAS toucher EEADR trop vite!
	call	WAIT_1ms	;et aussi NE PAS toucher EEADR trop vite!
	movfw	TMP
	banksel	EECON1		;bk3
	btfsc	EECON1,WR	;encore occupe  ecrire?
	goto	$-1			;oui, ne pas toucher  EEADR!!!

	banksel	EEDATA		;bk2
	movwf	EEDATA		;met car ds EEDATA
	
	banksel	EECON1		;bk3
	bcf		EECON1,EEPGD;OK,b7=0 pointe vers EEP
	bsf		EECON1,WREN	;enable Write

	movlw	h'55'		;magic sequence
	movwf	EECON2		;registre virtuel
	movlw	h'AA'
	movwf	EECON2
	bsf		EECON1,WR	;set bit Write
	bcf		EECON1,WREN	;disable Write

						;pour simulateur!!!!!!!
	call	WAIT_1ms	;et aussi NE PAS toucher EEADR trop vite!
	call	WAIT_1ms	;et aussi NE PAS toucher EEADR trop vite!
	call	WAIT_1ms	;et aussi NE PAS toucher EEADR trop vite!	
	call	WAIT_1ms	;et aussi NE PAS toucher EEADR trop vite!
	call	WAIT_1ms	;et aussi NE PAS toucher EEADR trop vite!
	call	WAIT_1ms	;et aussi NE PAS toucher EEADR trop vite!	

	banksel	EEADR
	incf		EEADR,f		;EEADR++, sets Z=1 si EEADR=0
	banksel	0
	btfss	STATUS,Z	;EEADR pointe  0 pour la prochaine criture,
	return		;pas 0, tout va bien
	call	AFFIC1A4	; oui 0, EEPROM pleine, signaler en affichant 1/4  4/4 en boucle
	goto	$-1

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;	


       #include <D_arith.inc>	;Package pour arith 16 bits
       ; b+a ds b;;;;;;;b  _ a  ds b;;;;;a*b  ds bHigh  cLow;;;;;;  b/a  res ds b, reste ds c

	end
	
	;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	
;	Etalonnage du cadran  ( effectuer  une seule fois).



;Pousser BPE et mettre le contact;
;;;;;;;;;;;;;;;;;;;On obtient  L2 off, L1 on

;Pousser BPP: l'aiguille du cadran se dplace vers la droite: l'arrter sur 1/4
; Si par mgarde on dpasse la position dsire, continuer  pousser BPP, l'aiguille va au maxi et revient  0. 
;Pousser BPE pour mmoriser la position 1/4

;;;;;;;;;;;;;;;;;;;;;;On obtient  L2 on, L1 off
;Pouser BPP pour mettre l'aiguille sur 1/2
;Pousser BPE pour mmoriser la position 1/2.

;;;;;;;;;;;;;;;;;;;;On obtient  L2 on, L1 on
;Pouser BPP pour mettre l'aiguille sur 3/4
;Pousser BPE pour mmoriser la position 3/4

;;;;;;;;;;;;;;;;;;;;;;;;On obtient  L2 on, L1on/ clignotantes
;Pouser BPP pour mettre l'aiguille sur 4/4
;Pousser BPE pour mmoriser la position 4/4


;L'talonage est termin, couper le contact.

:
