;   Fichier    D_arith.inc
;*******************************************************************
;                    Multiplication 16 x 16 bits
;
;                        ( Version courte )
;
;*******************************************************************
;   Multiplication : ACCb(16 bits) * ACCa(16 bits) -> ACCb,ACCc ( 32 bits )
;      (a) premier operande en ACCaLO & ACCaHI ( 16 bits )
;      (b) second operande en  ACCbLO & ACCbHI ( 16 bits )
;      (c) appel de D_mpy
;      (d) le resultat est en  ACCbHI,ACCbLO,ACCcHI,ACCcLO
;
;   Performances :
;               Taille mmoire  :       033
;               Nb de cycles    :       333
;
;
; D'aprs la note d'application AN 526 de Microchip, bug ds D_add corrige
;  31/12/2002  Ph Loutrel
;*******************************************************************
; IL FAUT CES VARIABLES DANS LE PROG UTILISANT CE PACKAGE
;	cblock	h'22'	
;	ACCaLO  
;	ACCaHI  
;	ACCbLO  
;	ACCbHI  
;	ACCcLO 
;	ACCcHI  
;	ACCdLO  
;	ACCdHI  
;	Dtemp
;	Dflags  
;  	endc

;	org     0
;	GOTO	MAIN

;         Addition double prcision ( ACCb + ACCa -> ACCb )
;
D_sub	call	neg_A
D_add	bcf	Dflags,0	;Quand une carry se produit ds l'addition
				;des L_bytes, ET que ACCbHI=h'FF', il faut
				;la stocker ds Dflags pour forcer C=1  la sortie
				;qqsoit le resultat de l'addition des H_bytes   
	movf    ACCaLO,w        ; Addition ( ACCb + ACCa -> ACCb )
	addwf   ACCbLO,f          ; Ajout lsb
	movlw	1		;Bug, manquait cette instruction
	btfsc   STATUS,C        ; Ajout retenue
	addwf   ACCbHI,f	;Bug, remplace INC qui n'affectait pas C
	btfsc	STATUS,C
	bsf	Dflags,0
	movf    ACCaHI,w
	addwf   ACCbHI,f         ; Ajout msb
	btfsc	Dflags,0
	bsf     STATUS,C
	return
;*******************************************************************
;
neg_A   comf    ACCaLO,f          ; ngation de ACCa ( -ACCa -> ACCa )
	incf    ACCaLO,f
	btfsc   STATUS,Z
	decf    ACCaHI,f
	comf    ACCaHI,f
	return
;
;
;*******************************************************************
;             Multiplication double prcision ( 16x16 -> 32 )
;  ( ACCb*ACCa -> ACCb,ACCc ) : rsultat sur 32 bits, poids forts
;dans ACCb ( ACCbHI,ACCbLO ) et poids faibles dans ACCc ( ACCcHI,ACCcLO ).
;
D_mpy                           ; resultat ds ACCb(16 msb) et ACCc(16 lsb)

	call    Dsetup
Dloop   rrf     ACCdHI,f          ; rotation de d  droite
	rrf     ACCdLO,f
	btfsc   STATUS,C        ; addition ncessaire ?
	call    D_add
	rrf     ACCbHI,f
	rrf     ACCbLO,f
	rrf     ACCcHI,f
	rrf     ACCcLO,f
	decfsz  Dtemp,f            ; boucle jusqu' tester tous les bits
	goto    Dloop
	return
Dsetup	movlw   d'16'            ; pour 16 dcalages
	movwf   Dtemp
	movf    ACCbHI,w        ; dplace ACCb dans ACCd
	movwf   ACCdHI
	movf    ACCbLO,w
	movwf   ACCdLO
	clrf    ACCbHI
	clrf    ACCbLO
	return



;*******************************************************************
;                     Division 16 bits par 16 bits
;
;                          ( Version courte )
;ATTENTION!! toujours  b>a *******************************
;*******************************************************************
;   Division : ACCb(16 bits) / ACCa(16 bits) -> ACCb(16 bits) 
;                                    Reste dans ACCc(16 bits)
;
;      (a) Diviseur dans  ACCaHI & ACCaLO ( 16 bits )
;      (b) Dividende dans ACCbHI & ACCbLO ( 16 bits )
;      (c) Appel de D_div
;      (d) Quotient sur 16 bits dans ACCbHI & ACCbLO
;      (e) Reste sur 16 bits dans    ACCcHI & ACCcLO
;
;   Performances :
;               Taille mmoire  :       037
;               Nb de cycles    :       310
;


; Avant l'appel de ce sous programme il faut s'assurer
; que le dividende est plus grand que le diviseur
;
D_div

	call    Dsetup
	clrf    ACCcHI
	clrf    ACCcLO
ddloop	bcf     STATUS,C
	rlf     ACCdLO,f
	rlf     ACCdHI,f
	rlf     ACCcLO,f
	rlf     ACCcHI,f
	movf    ACCaHI,w
	subwf   ACCcHI,w        ; test si a>c
	btfss   STATUS,Z
	goto    Dnochk
	movf    ACCaLO,w
	subwf   ACCcLO,w        ; si msb gaux, test des lsb
Dnochk	btfss   STATUS,C        ; retenue  1 si c>a
	goto    Dnogo
	movf    ACCaLO,w        ; c-a dans c
	subwf   ACCcLO,f
	btfss   STATUS,C
	decf    ACCcHI,f
	movf    ACCaHI,w
	subwf   ACCcHI,f
	bsf     STATUS,C        ; dcalage d'un 1 dans b (rsultat)
Dnogo	rlf     ACCbLO,f
	rlf     ACCbHI,f
	decfsz  Dtemp,f            ; boucle jusqu' tester tous les bits
	goto    ddloop
	return


	




